<template>
	<a-card :bordered="false" style="margin-bottom: 10px" class="mb-2">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form">
			<a-row :gutter="24">
				<a-col :span="6">
					<a-form-item label="订单编号" name="orderNumber">
						<a-input v-model:value="searchFormState.orderNumber" placeholder="订单编号查询" />
					</a-form-item>
				</a-col>
				<a-col :span="6">
					<a-form-item label="订单名称" name="orderName">
						<a-input v-model:value="searchFormState.orderName" placeholder="订单名称查询" />
					</a-form-item>
				</a-col>
				<a-col :span="6">
					<a-form-item label="客户名称" name="customerName">
						<a-input v-model:value="searchFormState.customerName" placeholder="客户名称查询" />
					</a-form-item>
				</a-col>
				<template v-if="advanced">
					<a-col :span="6">
						<a-form-item label="货品名称" name="goodsName">
							<a-input v-model:value="searchFormState.goodsName" placeholder="货品名称查询" />
						</a-form-item>
					</a-col>
					<a-col :span="6">
						<a-form-item label="订单状态" name="orderStatus">
							<a-select v-model:value="searchFormState.orderStatus" placeholder="订单状态查询"
									  :options="orderStatusList"
							> </a-select>
						</a-form-item>
					</a-col>
					<a-col :span="6">
						<a-form-item label="订单来源" name="orderSource">
							<a-select v-model:value="searchFormState.orderSource" placeholder="订单状态查询"
									  :options="orderSourceList"
							> </a-select>
						</a-form-item>
					</a-col>
				</template>
				<a-col :span="6">
					<a-button type="primary" @click="tableRef.refresh()">查询</a-button>
					<a-button style="margin: 0 8px" @click="reset">重置</a-button>
					<a @click="toggleAdvanced" style="margin-left: 8px">
						{{ advanced ? '收起' : '展开' }}
						<component :is="advanced ? 'up-outlined' : 'down-outlined'" />
					</a>
				</a-col>
			</a-row>
		</a-form>
	</a-card>
	<a-card :bordered="false">
		<s-table
			ref="tableRef"
			:columns="columns"
			:data="loadData"
			bordered
			:row-key="(record) => record.id"
		>
			<template #operator class="table-operator">
				<a-space>
					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('bizOrderAdd')">
						<template #icon><plus-outlined /></template>
						新增
					</a-button>
					<a-button @click="exportTotal" v-if="hasPerm('bizOrderExport')">
						<template #icon>
							<export-outlined/>
						</template>
						导出
					</a-button>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'orderType'">
					<a-tag
						:color="
							record.orderType === '1'
								? 'orange'
								: record.orderType === '2'
								  ? 'green'
								  : 'purple'
						"
					>
						{{ $TOOL.dictTypeData('order_type', record.orderType) }}
					</a-tag>
				</template>
				<template v-if="column.dataIndex === 'orderSource'">
					<a-tag
						:color="
							record.orderSource === '1'
								? 'orange'
								: record.orderSource === '2'
								  ? 'green'
								  : 'purple'
						"
					>
						{{ $TOOL.dictTypeData('order_source', record.orderSource) }}
					</a-tag>
				</template>
				<template v-if="column.dataIndex === 'orderStatus'">
					<a-tag
						:color="
							record.orderStatus === '1'
								? '#2db7f5'
								: record.orderStatus === '2'
								  ? '#f50'
								  : '#f50'
						"
					>
						{{ $TOOL.dictTypeData('order_status', record.orderStatus) }}
					</a-tag>
				</template>
				<template v-if="column.dataIndex === 'orderWeight'">
					{{record.orderWeight + '吨'}}
				</template>
				<template v-if="column.dataIndex === 'netWeight'">
					{{record.netWeight + '吨'}}
				</template>
				<template v-if="column.dataIndex === 'action'">

					<a @click="showModal(record)" v-if="record.customerId!=''&& record.customerId!=null">二维码</a>

					<a-divider type="vertical" v-if="record.customerId!=''&& record.customerId!=null"/>

					<a-dropdown v-if="(hasPerm('bizOrderEdit')) || (hasPerm('bizOrderDelete'))
						">
						<a class="ant-dropdown-link">
							更多
							<DownOutlined />
						</a>

						<template #overlay>
							<a-menu>
								<a-menu-item>
									<a size="small" type="link" @click="detailRef.onOpen(record)" >详情</a>
								</a-menu-item>
								<a-menu-item v-if="hasPerm('bizOrderEdit') && record.orderSource == '2' && record.orderStatus == '1'">
									<a style="color:blue" size="small" type="link" @click="formRef.onOpen(record)" >编辑</a>
								</a-menu-item>

								<a-menu-item v-if="hasPerm('bizOrderDelete') && record.orderSource == '2'">
									<a style="color:red" size="small" type="link" @click="deleteConfig(record)">删除</a>
								</a-menu-item>

								<a-menu-item v-if="record.orderStatus == '1'">
									<a style="color:orange" @click="selectCustomer(record)">绑定</a>
								</a-menu-item>

								<a-menu-item v-if="record.orderStatus == '1'">
									<a style="color:red" @click="endOrder(record)">结束</a>
								</a-menu-item>
							</a-menu>
						</template>
					</a-dropdown>

<!--					<a-space>
						<a @click="formRef.onOpen(record)" v-if="hasPerm('bizOrderEdit')">编辑</a>
						<a-divider type="vertical" v-if="hasPerm(['bizOrderEdit', 'bizOrderDelete'], 'and')" />
						<a-button type="link" danger size="small" v-if="hasPerm('bizOrderDelete')" @click="deleteConfig(record)">删除</a-button>
					</a-space>-->
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="tableRef.refresh()" />

	<Detail ref="detailRef" @successful="tableRef.refresh()" />


	<a-modal v-model:visible="open" title="二维码" width="600px" style="height: 700px">
		<div id="qrcode" style="text-align: center; margin:  15px 5px 15px 5px">
			<a-row>
				<a-col :span="13" id="colFlag">
					<div style="margin-top:10px;font-size:16px;">
						<p id="projectNameFlag">订单名称：{{nowRecord.orderName}}</p>
						<p id="projectCodeFlag">订单编码：{{ nowRecord.orderNumber }}</p>
						<p id="projectCodeFlag">客户名称：{{ nowRecord.customerName }}</p>
						<p id="projectCodeFlag">货品名称：{{ nowRecord.goodsName }}</p>
						<p id="projectCodeFlag">订单来源：{{ $TOOL.dictTypeData('order_source', nowRecord.orderSource) }}</p>
					</div>
				</a-col>
				<a-col :span="11">
					<a-image width="250"  height="100%" :src="qrCodeUrl.codeUrl"></a-image>
				</a-col>
			</a-row>
		</div>
		<template #footer>
			<a-button @click="closeQrCode">关闭</a-button>
			<a-button type="primary" @click="downloadFile">下载</a-button>
		</template>
	</a-modal>


	<xn-customer-selector
		ref="CustomerSelectorPlusRef"
		:add-show="false"
		:show="false"
		:role-global="true"
		@onBack="customerBack"
	/>
</template>

<script setup name="bizorder">
	import { cloneDeep } from 'lodash-es'
	import Form from './form.vue'
	import Detail from './detail.vue'
	import bizOrderApi from '@/api/biz/bizOrderApi'
	import {ExclamationCircleOutlined} from '@ant-design/icons-vue';
	import {Modal} from 'ant-design-vue';
	import {createVNode} from 'vue';
	import QRCode from 'qrcode'
	import html2canvas from 'html2canvas'
	import userApi from '@/api/sys/userApi'
	import downloadUtil from '@/utils/downloadUtil'
	import tool from '@/utils/tool'

	const selectedRecord = ref({})
	const CustomerSelectorPlusRef = ref()
	const nowRecord = ref()
	const tableRef = ref()
	const formRef = ref()
	const detailRef = ref()
	const submitLoading = ref(false)
	const toolConfig = { refresh: true, height: true, columnSetting: true, striped: false }

	//查询数据
	const searchFormState = ref({})
	const searchFormRef = ref()
	const orderStatusList = tool.dictList('order_status')
	const orderSourceList = tool.dictList('order_source')

	// 查询区域显示更多控制
	const advanced = ref(false)
	const toggleAdvanced = () => {
		advanced.value = !advanced.value
	}

	const columns = [
		{
			title: '订单编号',
			dataIndex: 'orderNumber',
			align:'center',
			width: 150
		},
		{
			title: '订单名称',
			dataIndex: 'orderName',
			align:'center',
			width: 150
		},
		{
			title: '客户名称',
			dataIndex: 'customerName',
			align:'center',
			width: 150
		},
		{
			title: '货品名称',
			dataIndex: 'goodsName',
			align:'center',
			width: 150
		},
		/*{
			title: '订单类型',
			dataIndex: 'orderType',
			align:'center'
		},*/
		{
			title: '订单来源',
			dataIndex: 'orderSource',
			align:'center',
			width: 100
		},
		{
			title: '订单状态',
			dataIndex: 'orderStatus',
			align:'center',
			width: 100
		},
		{
			title: '订单重量',
			dataIndex: 'orderWeight',
			align:'center',
			width: 100
		},
		{
			title: '过磅重量',
			dataIndex: 'netWeight',
			align:'center',
			width: 100
		},
	]
	// 操作栏通过权限判断是否显示
	columns.push({
		title: '操作',
		dataIndex: 'action',
		align: 'center',
		width: 150
	})

	const selectedRowKeys = ref([])
	// 列表选择配置
	const options = {
		// columns数字类型字段加入 needTotal: true 可以勾选自动算账
		alert: {
			show: true,
			clear: () => {
				selectedRowKeys.value = ref([])
			}
		},
		rowSelection: {
			onChange: (selectedRowKey, selectedRows) => {
				selectedRowKeys.value = selectedRowKey
			}
		}
	}
	const loadData = (parameter) => {
		const searchFormParam = cloneDeep(searchFormState.value)
		return bizOrderApi.bizOrderPage(Object.assign(parameter, searchFormParam)).then((data) => {
			return data
		})
	}
	// 重置
	const reset = () => {
		searchFormRef.value.resetFields()
		tableRef.value.refresh(true)
	}
	// 删除
	const deleteBizOrder = (record) => {
		let params = [
			{
				id: record.id
			}
		]
		bizOrderApi.bizOrderDelete(params).then(() => {
			tableRef.value.refresh(true)
		})
	}
	// 删除
	const deleteConfig = (record) => {

		Modal.confirm({
			title: '确定删除该数据吗？',
			icon: createVNode(ExclamationCircleOutlined),
			content: '',
			onOk() {
				submitLoading.value = true
				let params = [
					{
						id: record.id
					}
				]

				bizOrderApi
					.bizOrderDelete(params)
					.then(() => {
						tableRef.value.refresh(true)
					})
					.finally(() => {
						submitLoading.value = false
					})
			},
			onCancel() {}
		})
	}
	// 批量删除
	const deleteBatchBizOrder = (params) => {
		bizOrderApi.bizOrderDelete(params).then(() => {
			tableRef.value.clearRefreshSelected()
		})
	}

	//二维码
	const open = ref(false);
	const qrCodeUrl = ref({})
	const showModal = (record) => {
		nowRecord.value = record
		open.value = true;
		getQrCode(record)

	};

	const getQrCode = (record) => {
		//QRCode.toDataURL("id:"+record.id+"saleCode:"+record.saleCode, {
		let param = {
			id:record.id
		}
		QRCode.toDataURL(JSON.stringify(param), {
			errorCorrectionLevel: 'H',
			margin: 1,
			height: 206,
			width: 206,
			type: '10',
			scal: 177,
			color: {
				dark: '#000' // 二维码背景颜色
			},
			rendererOpts: {
				quality: 0.9
			}
		})
			.then((url) => {
				qrCodeUrl.value.codeUrl = url
			})
			.catch((err) => {
				console.error(err)
			})
	}

	const closeQrCode = () => {
		open.value = false;
	}

	// 下载二维码
	const downloadFile = () => {
		const qrcodeDiv = document.getElementById('qrcode');
		html2canvas(qrcodeDiv, {
			logging: false,
			allowTaint: true,
			scale: window.devicePixelRatio,
			scrollY: 0,
			scrollX: 0,
			useCORS: true,
			backgroundColor: '#ffffff'
		})
			.then(function (canvas) {
				const a = window.document.createElement('a')
				a.href = canvas.toDataURL('image/png')
				a.download = '二维码'
				a.click()
				this.$message.success('正在进行下载保存')
			})
			.catch((err) => {
				console.log(err)
			})
	}


	// 打开角色选择器
	const selectCustomer = (record) => {
		selectedRecord.value = record
		// 查询到已有角色，并转为ids的格式，给角色选择器
		CustomerSelectorPlusRef.value.showModel(record.customerId)
	}
	// 角色选择回调
	const customerBack = (value) => {
		let params = {
			id: selectedRecord.value.id,
			customerIdList: []
		}
		if (value.length > 0) {
			value.forEach((item) => {
				params.customerIdList.push(item)
			})
		}
		bizOrderApi.bindCustomerId(params).then(() => {
			tableRef.value.refresh()
		})
	}


	//导出
	const exportTotal = () => {
		const searchFormParam = cloneDeep(searchFormState.value)
		bizOrderApi.exportRecord(Object.assign(searchFormParam)).then((res)=>{
			downloadUtil.resultDownload(res)
		})
	}

	//结束订单
	const endOrder = (record) => {
		/*let param = {
			id:record.id
		}
		bizOrderApi.endOrder(param).then((res)=>{
			tableRef.value.refresh()
		})*/

		Modal.confirm({
			title: '确定结束该订单吗？',
			icon: createVNode(ExclamationCircleOutlined),
			content: '',
			onOk() {
				submitLoading.value = true
				let param = {
					id:record.id
				}

				bizOrderApi
					.endOrder(param)
					.then(() => {
						tableRef.value.refresh(true)
					})
					.finally(() => {
						submitLoading.value = false
					})
			},
			onCancel() {}
		})
	}
</script>
